!function(win,widget){
    var exports = widget.district || (widget.district = {});
    var Http=lib.http;
    var districtCache={};
    var districtData = {};
    var nickname={
        32:"新疆"
    };
    var gettingDistrict=true,fetchAreaSourceQueue=[];
    var initFunc = [];
    //先加载地区JS文件。
    function getCompleteFunc(){
        gettingDistrict=false;
        for(var i = 0; i < fetchAreaSourceQueue.length; i++){
            fetchAreaSource.apply(this,fetchAreaSourceQueue[i]);
        }
        fetchAreaSourceQueue=[];
    }
    function setDistrictCache(responseData){
        var district = responseData;
        var sort=["provinces","citys","districts"];
        districtCache={0:[]};
        for(var i=0;i<sort.length;i++){
            for(var pid in district[sort[i]]){
                if(sort[i] == "provinces"){
                    districtCache[0].push(district[sort[i]][pid]);
                }else{
                    districtCache[pid]=district[sort[i]][pid];
                }
            }
        }
        districtData = responseData;
    }
    function parseAreaData(data){
        var result = [];
        var sort=["provinces","citys","districts"];
        var pid;
        for(var n=0;n<data.length;n++){
            var sortName = sort[n];
            if(sortName=='provinces'){
                for(var i = 0;i<districtData[sortName].length;i++){
                    var provinceItem = districtData[sortName][i];
                    if(provinceItem[1]==data[n]){
                        result.push(provinceItem);
                        pid = provinceItem[0];
                        break;
                    }
                }
            }else if(pid) {
                var itemArr = districtData[sortName][pid];pid = null;
                for(var i = 0;i<itemArr.length;i++){
                    var itemData  = itemArr[i];
                    if(itemData[1]==data[n]){
                        result.push(itemData);
                        pid = itemData[0];
                        break;
                    }
                }
            }
        }
        return result;
    }
    var last_time,hasCallCompleteFunc = 0;
    if(window.localStorage.getItem('district.all')){
        try{
            var response = JSON.parse(window.localStorage.getItem('district.all'));
            last_time = response._cache;
            setDistrictCache(response.data);
            getCompleteFunc();
            hasCallCompleteFunc = 1;
            exports.init();
        }catch(e){
            last_time = null;
        }
    }
    Http.post({
        method:'district.all',
        last_time:last_time?last_time:''
    }).then(function(response){
        if(response.errcode==0){
            if(!$.isEmptyObject(response.data) ){
                setDistrictCache(response.data);
                response._cache = new Date().getTime();
                window.localStorage.setItem('district.all',JSON.stringify(response));
                if(!hasCallCompleteFunc){
                    getCompleteFunc();
                    hasCallCompleteFunc = 1;
                    exports.init();
                }
            }
        }
    },function(){
        if(!hasCallCompleteFunc){
            getCompleteFunc();
            hasCallCompleteFunc = 1;
            exports.init();
        }
    });


    function shortItemName(item){
        return ((item.id in nickname)?nickname[item.id]:item.label.replace(/\B(省|(自治州)|(自治区)|(自治县)|(地区)|(.族))/g,"")).substr(0,4);
    }
    function fetchAreaSource(pid,callback){
        if(gettingDistrict == true){
            fetchAreaSourceQueue.push([pid,callback]);
        }else{
            if(typeof(pid)=="function")callback=pid,pid=0;
            if(typeof(pid)=='undefined'||pid===''){
                if(typeof(callback)=="function")callback([]);
            }else if(pid in districtCache){
                if(typeof(callback)=="function")callback(districtCache[pid]);
            }else{
                Http.post({
                    method:'district.child',
                    district_id:pid,
                    _loading:true
                }).then(function(response){
                    if(response.errcode==0) {
                        districtCache[pid]=response.data;
                        if(typeof(callback)=="function")callback(districtCache[pid]);
                    }
                });
            }
        }
    }
    function createOption(data,selected,label){
        var html=["<option value=''>"+(label?label:"请选择")+"</option>"];
        for(var i=0;i<data.length;i++){
            if(data[i] instanceof Array)data[i]={id:data[i][0],label:data[i][1]};
            html.push("<option "+(selected==data[i].id?"selected='selected'":"")+" value='"+data[i].id+"'>"+shortItemName(data[i])+"</option>");
        }
        return html.join("");
    }
    function render(selectors,defaults,readyFun,labels){
        var flag=0;
        if(!labels)labels=[];
        var _selectors=[];
        $(selectors).each(function(index){
            _selectors.push($(this));
            $(this).change(function(){
                if(selectors.length>index+1){
                    fetchAreaSource($(this).val(),function(data){
                        $(selectors).each(function(i){
                            if(i<=index)return;
                            $(this).html(createOption((i==index+1)?data:[],-1,labels[i]));
                        });
                    });
                }
            });
        });
        setDefault(selectors,defaults,readyFun,labels);
    }
    function selector(options){
        var _defaults = {
            selects: '',
            defaults:[0],
            ready:null,
            labels:['请选择省','请选择市','请选择县','请选择街道']
        };
        options = $.extend({},_defaults,options);
        var selectors = options.selects,defaults = options.defaults, readyFun = options.ready, labels = options.labels;
        render(selectors,defaults,readyFun,labels);
        this.select = function(defaults,callback){
            if(arguments.length==0){
                var result = [];
                $(selectors).each(function(){
                    result.push($(this).val());
                });
                return result;
            }else{
                setDefault(selectors,defaults,callback,labels);
                return this;
            }
        };
        this.clear = function(){
            setDefault(selectors,null,null,labels);
            return this;
        };

    }
    function setDefault(selectors,defaults,readyFun,labels){
        var flag=0;
        if(defaults===null){
            $(selectors).each(function(index){
                if(index==0){
                    $(selectors).find('option').attr('selected',false);
                }else{
                    $(selectors).eq(index).html(createOption([],null,labels[index]));
                }
            });
        }else if($.isArray(defaults)) {
            $.isArray(defaults)?defaults.unshift(0):defaults=[0];
            $(defaults).each(function(i,selected){
                if(defaults.length>1&&(i+2)>defaults.length)return ;flag++;
                fetchAreaSource(selected,function(data){
                    $(selectors).eq(i).html(createOption(data,defaults[i+1],labels[i]));flag--;
                    if(flag==0){
                        if(typeof(defaults)=="function"){
                            readyFun = defaults;
                            readyFun($(selectors));
                        }else if(typeof(readyFun)=="function")readyFun($(selectors));
                    }
                });
            });
        }
    }
    function ipLocation(callback){
        Http.post({
            method:'sys.location',
            _cache:2*60*60
        }).then(callback);
    }
    function hasChildren(pid){
        return districtCache[pid];
    }
    exports.render=render;
    exports.setDefault=setDefault;
    exports.selector=selector;
    exports.ipLocation=ipLocation;
    exports.shortItemName=shortItemName;
    exports.fetchAreaSource=fetchAreaSource;
    exports.hasChildren=hasChildren;
    exports.parseAreaData=parseAreaData;
    exports.init = function(callback){
        typeof(callback)=='function'&&initFunc.push(callback);
        if(hasCallCompleteFunc){
            for(var i=0;i<initFunc.length;i++){
                initFunc[i]();
            }
            initFunc = [];
        }
    }
}(window,window['widget'] || (window['widget'] = {}));