!function(win,widget){
    var Event = lib.event,Http = lib.http;
    function goods(goodsModel){
        var _defaultGoodsModel = {
            "shop_id": "",
            "goods_id": "",
            "goods_name": "",
            "post_type": 1,
            "store_type": 0,
            "product_list": {
                "stock": {
                    /*
                     "spec_group": {
                     "count": "100",
                     "price": "2000.00",
                     "prod_id": "54"
                     }
                     */
                },
                "count": 0,
                "price": 0,
                "total_stock": 0
            },
            "goods_spec": {
                /*
                 "spec_id": {
                 "id": "spec_id",
                 "name": "spec_name",
                 "type": "1",
                 "value": [{"spec_value_label": "spec_value_img"}]
                 }
                 */
            }
        };
        var _this = this;

        var selectedSpecs = [];

        var productStore  = {},specLabel2ProdIdStore = {};

        var productId,total_stock = 0,price_range = '';

        var quantity = 1;

        var freight = '--';

        var is_post = 1;

        var districtId = -1;

        goodsModel = $.extend({},_defaultGoodsModel,goodsModel);


        function floorIncome(number){
            return (Math.floor(number*100)/100).toFixed(2);
        }

        function formatSpecKeysString(specKeysString){
            var specKeysArr = specKeysString.split('|||');
            specKeysArr.sort(function(a,b){
                return b>a?1:-1;
            });
            return specKeysArr.join('|||');
        }

        function parseSalesInfo (originProductList){
            for(var key in originProductList['stock']){
                var specLabel = formatSpecKeysString(key);
                var productId = originProductList['stock'][key].prod_id;
                specLabel2ProdIdStore[specLabel] = productId;
                productStore[productId] = originProductList['stock'][key];
            }
            total_stock = originProductList['total_stock'];
            price_range = originProductList['price'];
        }

        function getGoodsId(){
            return goodsModel.goods_id;
        }
        function getProductId(){
            return productId;
        }

        function setSelectedSpecs (selectedSpecsArr){
            var _productId;
            if($.isEmptyObject(goodsModel.goods_spec)&&Object.keys(goodsModel.product_list.stock).length==1){
                var defaultKey = Object.keys(goodsModel.product_list.stock)[0];
                _productId = goodsModel.product_list.stock[defaultKey]['prod_id'];
            }else{
                selectedSpecsArr.sort(function(a,b){
                    return b>a?1:-1;
                });
                selectedSpecs = selectedSpecsArr;
                _productId = specLabel2ProdIdStore[selectedSpecsArr.join('|||')] ;
            }
            if(productId != _productId){
                productId = _productId;
                _this.dispatchEvent({
                    type:'salesChanged',
                    target:this
                });
            }
        }

        function getSalesInfo(){
            var productId = getProductId();
            if(productStore[productId]){
                return productStore[productId];
            }else{
                return false;
            }
        }

        function setDistrictId(id){
            districtId = id;
            if(goodsModel['post_type']==2||goodsModel['not_delivery_tpl_id']>0){
                return freshFreightInfo();
            }
        }

        function getDistrictId(){
            return districtId;
        }

        function setQuantity(amount){
            quantity = amount;
            if(goodsModel['post_type']==2&&districtId>-1){
                return freshFreightInfo();
            }
        }

        function getFreight(){
            return freight;
        }

        function isPost(){
            return is_post>0;
        }

        var st;
        function freshFreightInfo(){
            clearTimeout(st);
            st = setTimeout(function(){
                Http.post({
                    method:'market.goods.freight',
                    district_id:districtId,
                    quantity:quantity,
                    shop_id:goodsModel['shop_id'],
                    goods_id:goodsModel['goods_id']
                }).then(function(response){
                    if(response.errcode==0){
                        freight = Number(response.data.freight_fee).toFixed(2);
                        if(freight<=0){
                            freight = '免运费';
                        }
                        is_post = response.data.is_post;
                        _this.dispatchEvent({
                            type:'deliveryInfoChanged',
                            target:this
                        });
                    }
                })
            },50);
        }

        parseSalesInfo(goodsModel.product_list);

        if(goodsModel['post_type']==1){
            freight = '免运费';
        }else if(goodsModel['post_type']==2){
            freight = '--';
        }else if(goodsModel['post_type']==3){
            freight = goodsModel['post_value'];
        }

        this.setSelectedSpecs = setSelectedSpecs;
        this.setDistrictId = setDistrictId;
        this.getDistrictId = getDistrictId;
        this.setQuantity = setQuantity;
        this.getFreight = getFreight;
        this.isPost = isPost;
        this.getSalesInfo = getSalesInfo;
        this.getProductId = getProductId;
        this.getGoodsId = getGoodsId;

    }
    Event.extend.call(goods);
    widget.goods = goods;
}(window, window['widget'] || (window['widget'] = {}))